{JESSBOT

RTC and Display working

Leds

'buzzer
'random
'leds
'pulse
'display
'clock
'debug

}

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

CON 'whats on?
 buzzerON=1     '1 cog
 randomON=0     '1 cog
 ledstestON=0   '1 cog
 pulseON=1      '0 cog
 displayON=1    '0 cog
 clockON=1
 debugON=1      '1 cog
 showTDYON=1    '1 cog
 chimeON=1
 rrON=0         '2 cogs
 setconfigtime=1 '0 cog
 ledpwmON=1
 checkactON=1

CON 'cog assignments

  buzzerONcog=7
  debugONcog=4
  showtdyONcog=5
  checkactONcog=6

CON 'initial clock assignments
 cmonth=10
 cday=9
 cyear=14
 cdow=5
 cmin=32
 chour=18
 csec=20

CON 'pin assigments
   debugled = 0
   segi2cA=$70
   segSCL=9
   _receiverPin = 31
   _transmitterPin = 30
   _clock =4
   _clockio =3
   _clockce =2
  ledstart =12
  ledendd =27
  buzzer = 1
con 'other assigments
  _numleds = 16
  _firstled = 12
  _maxbright = 32
  _delay = 180
  _baudRateSpeed = 115200
  _newLineCharacter = 13
  _clearScreenCharacter = 16
  _homeCursorCharacter = 1
  RANGE         = 127            'Range is 0 to RANGE.
  SAMPLES       = 20            'Number of samples to pick: 1 to RANGE + 1
  FRange =   127
  FSAMPLES = 20
  _mask = %0000_0000_0000_0001

VAR
  byte clocklockID
  byte debugStack[300],buzzerStack[100],ledStack[200],clockstack[200],showTDYstack[200],randomledsstack[200],checkactstack[200]
  byte hour, minute, second, day, month, year, dow
  byte thour, tminute, tsecond, tday, tmonth, tyear, tdow
  byte ADDR        ' Backpack I2C address
  byte PIN_SCL     ' I/O pin connected to SCL (SDA is very next pin)
  byte cmd, out
  byte clockdata[12]
  byte ledsONcog,pulseONcog,displayONcog,clockONcog,rrONcog,ledpwmONCOG
  byte rnumbers[RANGE + 1],fnumbers[RANGE+1]
  byte frannum
  long rannum
  long displaydigits,ledpattern '16 bits
  long notex
  long numleds_, firstled_, persistence_, leds[_numleds]    'these must appear in this order
OBJ
  SN    : "Simple_Numbers"
  rtc   : "DS1302_fulljs"
  'com: "RS232_COMEngine.spin"
  'str: "ASCII0_STREngine.spin"
  i2c : "Basic_I2C_Driver_1"
  'spi : "Spi_spin"
  'seg : "ht16k33_7seg"
  ledpwm        : "led_pwm"
  'prng       : "jkiss32"
  'RandomNumb : "RealRandom"  'COG
  debug:"Parallax Serial Terminal Plus.spin"

PUB start


  'ledpwmONcog:=2


  if buzzerON==1
     coginit(buzzerONcog,freqStart(buzzer,1),@buzzerStack[0])
     bootsound
     waitcnt(clkfreq/10 + cnt)
  if clockON==1
     clockStart
     clockONcog:=0
  if debugON==1
     coginit(debugONcog,dodebug,@debugStack[0])
  if ledstestON==1
     ledsONcog:=cognew(ledtest,@ledstack[0])
  if displayON==1
     initdisplay(segi2cA,segSCL)'i2c
     'counting(200,250)
     hellojess
     displayONcog:=1
     if showTDYON==1
        coginit(showtdyONcog,showTDY,@showTDYstack[0])
  if pulseON==1
     dira[debugled]:=1
  else
     dira[debugled]:=0
  if checkactON==1
     coginit(checkactONcog,checkact,@checkactstack[0])

  repeat
   if clockon==1
     rtc.readTime(@hour, @minute, @second)     'read time from DS1302
     rtc.readDate(@day, @month, @year, @dow)   'read date from DS1302
   !outa[debugled]
   waitcnt(clkfreq/5 + cnt)

pub showTDY

   repeat
      showdate
      showyear
      showtime

pub checkact

    if clockon==1 and chimeON==1
      repeat
        'rtc.readTime(@hour, @minute, @second)     'read time from DS1302
        'rtc.readDate(@day, @month, @year, @dow)   'read date from DS1302
        if month==11 and day==2 and hour ==2 and minute == 0 and second==0
           rtc.setDatetime(11,2,14,1,1,0,2)
        if month== 3 and day==8 and hour ==2 and minute == 0 and second==0
           rtc.setDatetime( 3,8,15,1,3,0,2)
        if month== 5 and day==19 and minute == 0 and second=<2
           if hour > 8 and hour < 18
              hbsound
        if minute == 0 and second =< 2
              PulsePattern(hour,hour)
        if second == 0 'or second == 20 or second == 30 or second == 40 or second == 50
              PulsePattern(4,3)

     'waitcnt(clkfreq*1+cnt)

pub showtime|w,x,y,z

    case hour
      0..9:
           x:=hour
           w:=0
      10..19:
           x:=hour-10
           w:=1
      20..23:
           x:=hour-20
           w:=2
    case minute
      0..9:
           z:=minute
           y:=0
      10..19:
           z:=minute-10
           y:=1
      20..29:
           z:=minute-20
           y:=2
      30..39:
           z:=minute-30
           y:=3
      40..49:
           z:=minute-40
           y:=4
      50..59:
           z:=minute-50
           y:=5

    writeDigit($08,numbers[z])'---M
    writeDigit($06,numbers[y])'--M-
    writeDigit($04,-1)
    writeDigit($02,numbers[x])'-H--
    writeDigit($00,numbers[w])'H---
    waitcnt(clkfreq*2 + cnt)

pub showdate|w,x,y,z

    case month
      00..09:
           x:=month
           w:=0
      10..12:
           x:=month-10
           w:=1
    case day
      0..9:
           z:=day
           y:=0
      10..19:
           z:=day-10
           y:=1
      20..29:
           z:=day-20
           y:=2
      30..31:
           z:=day-30
           y:=3
    writeDigit($08,numbers[z])'---d
    writeDigit($06,numbers[y])'--d-
    writeDigit($04,0)
    writeDigit($02,(%10000000|numbers[x]))'-m--
    writeDigit($00,numbers[w])'m---
    waitcnt(clkfreq*1 + cnt)

pub showyear|s,t,u,v

    case year
        20..29:
            u:=year-20
            v:=2
        19..10:
            u:=year-10
            v:=1
        09..00:
            u:=year
            v:=0
    s:=2
    t:=0
    writeDigit($08,numbers[u])'---d
    writeDigit($06,numbers[v])'--d-
    writeDigit($04,0)
    writeDigit($02,numbers[t])'-m--
    writeDigit($00,numbers[s])'m---
    waitcnt(clkfreq*1 + cnt)
{'the DS1306 returns a 4 digit year, the ds1302 a two digit year
      '2000..2009:
      '     u:=year-2000
      '     v:=0
      '2010..2019:
      '     u:=year-2010
      '     v:=1}
PRI clockStart'|_cmonth,_cday,_cyear,_cdow,_chour,_cmin,_csec

 rtc.init( _clock,_clockio,_clockce)
 rtc.write(rtc.command(rtc#clock,rtc#tc,rtc#w),(%1010 << 4) + (1 << 2)+ ( 1 ))
 if setconfigtime==1
  rtc.config                                    'Set configuration register
  rtc.setDatetime(cmonth,cday,cyear,cdow,chour,cmin,csec) 'month, day, year, day of week, hour, minute, second

PRI freqStart(spk,dur)

  dira[buzzer]:=%1
  ctra[30..26] := %00100               ' Set ctra for "NCO single-ended"
  ctra[5..0] := %00001                   ' Set APIN to P11
  repeat
    frqa := notex                      ' Set frqa for 2093 Hz (C7 note)                                     ' FRQA/B = frequency ? (232 ? clkfreq)
    Play(spk,dur)

PRI Play (spk,dur)  'Broadcast the signal for 1 s

  dira[spk]~~
  waitcnt(clkfreq / dur + cnt)

PRI dodebug

   debug.start(_baudRateSpeed)
   debug.Str(@debugboottext)
   repeat 25
      debug.str(string("."))
      waitcnt(clkfreq/20 + cnt)
   waitcnt(clkfreq/2 + cnt)
   debug.clear
   debug.Str(@debugOptionstext)
   repeat
     debug.Str(@debugOptionstext)
     debugoptions


PRI initdisplay(i2cAddress,pinSCL)

'' Initialize the object with the given I2C-address and hardware pins.
'' The driver I am using requires SDA to be the next pin after SCL.
'
  ADDR := i2cAddress
  PIN_SCL := pinSCL

  i2c.Initialize(PIN_SCL)

  setOscillator(1)            ' Start the oscillator
  setBlink(1,0)               ' Power on, no blinking
  setBrightness(%0001)           ' Max brightness

PRI ledtest

 ledpattern:=%1
 dira[ledstart..ledendd] := %1111_1111_1111_1111
 repeat
    outa[ledstart..ledendd] := ledpattern
    ledpattern<-=1
    waitcnt(clkfreq/25+cnt)

pub debugoptions

'debugoptionstext byte "buzzer",13,"random",13,"leds",13,"pulse",13,"display",13,"clock",13,"debug",13,"showTDY",0
    debug.position(28,6)
    Debug.str( string("\"))
    debug.position(8,0)
    if buzzerON==1
      debug.dec(buzzerON)
      debug.position(18, 0)
      debug.dec(buzzerONcog)
      debug.position(28, 0)
      debug.dec(notex)
    else
      Debug.str(string("-----buzzer off-----"))

    debug.position(8,2)
    if ledstestON==1
      debug.dec(ledstestON)
      debug.position(18,2)
      debug.dec(ledsONcog)
      debug.position(28,2)
      debug.bin(ledpattern,16)
    else
      Debug.str(string("---led test off-----"))

    debug.position(8,3)
    if pulseON==1
      debug.dec(pulseON)
      debug.position(18,3)
      debug.dec(pulseONcog)
      debug.position(28,3)
      Debug.str(string("*"))
    else
      Debug.str(string("---pulse    off-----"))

    debug.position(8,4)
    if displayON==1
      debug.dec(displayON)
      debug.position(18,4)
      debug.dec(displayONcog)
      debug.position(28,4)
      debug.bin(displaydigits,8)
    else
      Debug.str(string("---display  off-----"))

    debug.position(8,5)
    if clockON==1
      debug.dec(clockON)
      debug.position(18,5)
      debug.dec(clockONcog)
      debug.position(28,5)
      Debug.str( SN.decx(hour,2) )
      Debug.str( string(":"))
      Debug.str( SN.decx(minute,2) )
      Debug.str( string(":") )
      Debug.str( SN.decx(second,2))
      Debug.str( string(", ") )
      Debug.str( SN.decx(dow,2))
      Debug.str( string(" ") )
      Debug.str( SN.decx(month,2))
      Debug.str( string("/") )
      Debug.str( SN.decx(day,2))
      Debug.str( string("/") )
      Debug.str( SN.decx(year,2))
    else
      Debug.str(string("---clock    off-----"))

    debug.position(8,6)
    if debugON==1
       debug.dec(debugON)
       debug.position(18,6)
       debug.dec(debugONcog)
       debug.position(28,6)
       Debug.str( string("-"))
    else
      Debug.str(string("---debug   off-----"))

    debug.position(8,7)
    if showtdyON==1
      debug.dec(showtdyON)
      debug.position(18,7)
      debug.dec(showtdyONcog)
    else
      Debug.str(string("---showtdy  off-----"))

    debug.position(8,8)
    if rrON==1
      debug.dec(1)
      debug.position(18,8)
      debug.dec(rrONcog)
    else
      Debug.str(string("---rr  off-----"))

    debug.position(8,9)
    if ledpwmON==1
      debug.dec(1)
      debug.position(18,9)
      debug.dec(ledpwmONcog)
    else
      Debug.str(string("---ledpwmoff-----"))


    debug.position(8,10)
    if checkactON==1
      debug.dec(1)
      debug.position(18,10)
      debug.dec(checkactONcog)
      debug.position(28,10)
      debug.bin(ledpattern,16)
    else
      Debug.str(string("---chkactoff-----"))

PRI bootsound
        notex:=84181
        waitcnt(clkfreq/10 + cnt)
        notex:=63066
        waitcnt(clkfreq/10 + cnt)
        notex:=70786
        waitcnt(clkfreq/10 + cnt)
        notex:=56184
        waitcnt(clkfreq/10 + cnt)
        notex:=74993
        waitcnt(clkfreq/10 + cnt)
        notex:=0

PRI hbsound

        notex:=26200
        waitcnt(clkfreq/5 + cnt)
        notex:=0
        waitcnt(clkfreq/50 + cnt)
        notex:=26200
        waitcnt(clkfreq/5 + cnt)
        notex:=29400
        waitcnt(clkfreq/1 + cnt)
        notex:=26200
        waitcnt(clkfreq/1 + cnt)
        notex:=34900
        waitcnt(clkfreq/1 + cnt)
        notex:=33000
        waitcnt(clkfreq*2 + cnt)
        notex:=26200
        waitcnt(clkfreq/5 + cnt)
        notex:=0
        waitcnt(clkfreq/50 + cnt)
        notex:=26200
        waitcnt(clkfreq/5 + cnt)
        notex:=29400
        waitcnt(clkfreq/1 + cnt)
        notex:=26200
        waitcnt(clkfreq/1 + cnt)
        notex:=39200
        waitcnt(clkfreq/1 + cnt)
        notex:=34900
        waitcnt(clkfreq*2 + cnt)
        notex:=26200
        waitcnt(clkfreq/5 + cnt)
        notex:=0
        waitcnt(clkfreq/50 + cnt)
        notex:=26200
        waitcnt(clkfreq/5 + cnt)
        notex:=52399
        waitcnt(clkfreq/1 + cnt)
        notex:=44000
        waitcnt(clkfreq/1 + cnt)
        notex:=34900
        waitcnt(clkfreq/1 + cnt)
        notex:=33000
        waitcnt(clkfreq/1 + cnt)
        notex:=29400
        waitcnt(clkfreq*2 + cnt)
        notex:=46600
        waitcnt(clkfreq/1 + cnt)
        notex:=0
        waitcnt(clkfreq/50 + cnt)
        notex:=46600
        waitcnt(clkfreq/1 + cnt)
        notex:=44000
        waitcnt(clkfreq/1 + cnt)
        notex:=34900
        waitcnt(clkfreq/1 + cnt)
        notex:=39200
        waitcnt(clkfreq/1 + cnt)
        notex:=34900
        waitcnt(clkfreq*2 + cnt)
        notex:=0
{




C 16 33 65 131 262 523 1046 2093
C# 17 35 69 139 277 554 1109 2217
D 18 37 73 147 294 587 1175 2349
D# 19 39 78 155 311 622 1244 2489
E 21 41 82 165 330 659 1328 2637
F 22 44 87 175 349 698 1397 2794
F# 23 46 92 185 370 740 1480 2960
G 24 49 98 196 392 784 1568 3136
G# 26 52 104 208 415 831 1661 3322
A 27 55 110 220 440 880 1760 3520
A# 29 58 116 233 466 932 1865 3729
B 31 62 123 245 494 988 1975 3951
And here are the notes for Happy Birthday - the timing you can work on throught experiment yourself:
GGAGC#B GGAGD#C# GGG#E#C#BA F#F#E#C#DC#}
pub dim|br

     repeat br from %1000 to %0011
      setBrightness(br)           ' Max brightness
      waitcnt(clkfreq/5 + cnt)                         ' wait
     repeat br from %0010 to %0000
      setBrightness(br)           ' Max brightness
      waitcnt(clkfreq/5 + cnt)
PUB setOscillator(on) | address
'' Turn the oscillator on (or off)
'
'  0010_xxx_p
'
  address := ADDR << 1 ' # R/-W bit = 0 (write)
  on := on & 1
  on := on | $20

  i2c.Start(PIN_SCL)
  i2c.Write(PIN_SCL,address)
  i2c.Write(PIN_SCL,on)
  i2c.Stop(PIN_SCL)

PUB setBlink(power,rate)  | address
'' Set the display power and blink rate
''   rate = 00 = Off
''          01 = 2Hz
''          10 = 1Hz
''          11 = 0.5Hz
'
'  1000_x_rr_p
'
  address := ADDR << 1 ' # R/-W bit = 0 (write)
  rate := rate & 3
  rate := rate << 1
  power := power & 1
  rate := rate | power
  rate := rate | $80

  i2c.Start(PIN_SCL)
  i2c.Write(PIN_SCL,address)
  i2c.Write(PIN_SCL,rate)
  i2c.Stop(PIN_SCL)

PUB setBrightness(level) | address
'' Set the display brightness
'' level: 0000=minimum, 1111=maximum
'
'  1110_vvvv
'
  address := ADDR << 1 ' # R/-W bit = 0 (write)
  level := level & 15
  level := level | $E0

  i2c.Start(PIN_SCL)
  i2c.Write(PIN_SCL,address)
  i2c.Write(PIN_SCL,level)
  i2c.Stop(PIN_SCL)



pub writeDigit(register,data)|address

  displaydigits:=data
  address := ADDR << 1 ' # R/-W bit = 0 (write)
  i2c.Start(PIN_SCL)
  i2c.Write(PIN_SCL,address)
  i2c.Write(PIN_SCL,register)
  i2c.Write(PIN_SCL,data)
  'i2c.Write(PIN_SCL,(byte[data]& $FF))
  'i2c.Write(PIN_SCL,(byte[data] >> 8))
  i2c.Stop(PIN_SCL)


PUB writeDisplay(register,count,data) | address
'' Write a number of data values beginning with the
'' given register.

  address := ADDR << 1 ' # R/-W bit = 0 (write)
  i2c.Start(PIN_SCL)
  i2c.Write(PIN_SCL,address)
  i2c.Write(PIN_SCL,register)

  repeat while count>0
    i2c.Write(PIN_SCL,(byte[data]& $FF))
    i2c.Write(PIN_SCL,(byte[data] >> 8))
    data++ ':= data +1
    count-- ' := count -1

  i2c.Stop(PIN_SCL)

pub hellojess

    writeDigit($04,0)
    writeDigit($08,hello[0])
    writeDigit($06,hello[1])
    writeDigit($02,hello[2])
    writeDigit($00,hello[3])
    dim
    waitcnt(clkfreq/20 + cnt)
    dim
    writeDigit($08,jess[0])
    writeDigit($06,jess[1])
    writeDigit($02,jess[2])
    writeDigit($00,jess[3])
    dim
    waitcnt(clkfreq/20 + cnt)
    dim
    setBrightness(0)
pub blankdisplay
    writeDigit($08,blank[0])
    writeDigit($06,blank[0])
    writeDigit($04,%0) 'off colon
    writeDigit($02,blank[0])
    writeDigit($00,blank[0])

pub zerodisplay

    writeDigit($08,numbers[0])
    writeDigit($06,numbers[0])
    writeDigit($04,%0) 'off colon
    writeDigit($02,numbers[0])
    writeDigit($00,numbers[0])
    waitcnt(clkfreq/5 + cnt)

pub counting(delay,times)|w,x,y,z,temp

   writeDigit($04,0)
   'displaydigits:=w:=x:=y:=z:=0
   repeat temp from 0 to times
     if z++ > 8
       z:=0
       if y++ > 8
          y:=0
          if x++ > 8
             x:=0
             if w++ > 8
                w:=x:=y:=z:=0
     writeDigit($08,numbers[z])
     writeDigit($06,numbers[y])
     writeDigit($02,numbers[x])
     writeDigit($00,numbers[w])
     waitcnt(clkfreq/delay + cnt)

PUB PulsePattern(numpulses,pattern) | a,y,x,z, bright, maxbright
  {{
  This function disables the automatic decay of the led_pwm driver and instead controls
  the brightness manually, setting all LEDs to the same brightness value, then waiting a
  small delay. Changing the step value will alter how fast the pulsing happens.
  }}

  numleds_ := _numleds
  firstled_ :=_firstled
  maxbright := _maxbright
  rannum+=(second+minute)
  ledpwmONcog:=ledpwm.start(@numleds_)
  repeat numpulses
    a:=(?rannum>>16)
    notex:=ledpattern:=pattern:=a
    repeat bright from 0 to maxbright step 1
      repeat x from 0 to(_numleds-1)
        z:= pattern>>x & _mask
        if z==_mask
           leds[x] := bright
      waitcnt(clkfreq/_delay + cnt)                     ' The delay is after all are set, so they are unifor
    notex:=0
    repeat bright from maxbright to 0 step 1
      repeat x from (_numleds-1) to 0
        z:= pattern>>x & _mask
        if z==_mask
           leds[x] := bright
      waitcnt(clkfreq/_delay + cnt)                     ' The delay is after all are set, so they are uniform
  ledpwm.stop


dat
debugoptionstext byte 1,"buzzer",13,"random",13,"ledtest",13,"pulse",13,"display",13,"clock",13,"debug",13,"showTDY",13,"rr",13,"ledpwm",13,"checkact",0
debugtimetext byte "Time:",0
debugboottext byte "Booting...",0
textBuffer    byte 8,0'8 byte buffer but can be initial text.
one           byte "1",0
numbers       byte %00111111, %00000110, %01011011, %01001111, %01100110, %01101101, %01111101, %00000111, %01111111, %01101111 '0-9
hello         byte %00111111, %00110110, %01111001, %01110110, 0
jess          byte %01101101, %01101101, %01111001, %00001110, 0
blank         byte %00000000

DAT     '' Notes from chart @ http://www.phy.mtu.edu/~suits/notefreqs.html
        '' These values are ten times the actual frequencies.
           ''  c      c#     d      d#     e      f      f#     g      g#     a      a#     b
note    long   164,   173,   184,   195,   206,   218,   231,   245,   260,   275,   291,   309 ' C0 - B0
        long   327,   347,   367,   389,   412,   437,   463,   490,   519,   550,   583,   617 ' C1 - B1
        long   654,   693,   734,   778,   824,   873,   925,   980,  1038,  1100,  1165,  1235 ' C2 - B2
        long  1308,  1386,  1468,  1556,  1648,  1746,  1850,  1960,  2077,  2200,  2331,  2469 ' C3 - B3
        long  2616,  2772,  2937,  3111,  3296,  3492,  3700,  3920,  4153,  4400,  4662,  4939 ' C4 - B4
        long  5233,  5544,  5873,  6223,  6593,  6985,  7400,  7840,  8306,  8800,  9323,  9878 ' C5 - B5
        long 10465, 11087, 11747, 12445, 13185, 13970, 14800, 15680, 16612, 17600, 18647, 19755 ' C6 - B6
        long 20930, 22175, 23493, 24890, 26370, 27938, 29600, 31360, 33224, 35200, 37293, 39511 ' C7 - B7
        long 41860, 44349, 46986, 49780, 52740, 55877, 59199, 62719, 66449, 70400, 74586, 79021 ' C8 - B8

